> ## Documentation Index
> Fetch the complete documentation index at: https://walletconnect-pay-docs-tomiir-buyer-checkout-docs.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Get payment options

> List available options a wallet can use to complete a payment.



## OpenAPI

````yaml POST /v1/gateway/payment/{id}/options
openapi: 3.0.3
info:
  title: WalletConnect Pay API (Gateway)
  description: >-
    Gateway API for wallets to fulfill WalletConnect Pay payments (API-first /
    non-SDK flow).
  version: 0.0.0
servers:
  - url: https://api.pay.walletconnect.com
security:
  - API Key: []
paths:
  /v1/gateway/payment/{id}/options:
    post:
      tags:
        - Gateway
      summary: Get payment options
      description: >-
        This endpoint takes a list of accounts and returns a list of options
        that can be used to complete the payment.
      operationId: gatewayGetPaymentOptions
      parameters:
        - name: Api-Key
          in: header
          required: true
          schema:
            type: string
        - name: App-Id
          in: header
          required: false
          schema:
            type: string
        - name: id
          in: path
          description: Payment ID
          required: true
          schema:
            type: string
        - name: includePaymentInfo
          in: query
          description: Whether to include payment information in the response
          required: false
          schema:
            type: boolean
            nullable: true
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/GetPaymentOptionsRequest'
      responses:
        '200':
          description: Payment options retrieved successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetPaymentOptionsResponse'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '401':
          description: Invalid API key
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '404':
          description: Payment not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '500':
          description: Internal error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
components:
  schemas:
    GetPaymentOptionsRequest:
      type: object
      required:
        - accounts
      properties:
        accounts:
          type: array
          items:
            type: string
        refresh:
          type: array
          nullable: true
          items:
            type: string
    GetPaymentOptionsResponse:
      type: object
      required:
        - options
      properties:
        collectData:
          allOf:
            - $ref: '#/components/schemas/CollectData'
          nullable: true
        info:
          allOf:
            - $ref: '#/components/schemas/GetPaymentResponse'
          nullable: true
        options:
          type: array
          items:
            $ref: '#/components/schemas/PaymentOption'
    ErrorResponse:
      type: object
      description: Standard error response structure for API errors.
      required:
        - code
        - message
      properties:
        code:
          $ref: '#/components/schemas/ErrorCode'
        message:
          type: string
    CollectData:
      type: object
      properties:
        url:
          type: string
          description: WebView URL for data collection
        schema:
          type: object
          nullable: true
          description: JSON schema describing the required fields
        fields:
          type: array
          items:
            $ref: '#/components/schemas/CollectDataField'
    GetPaymentResponse:
      type: object
      required:
        - status
        - amount
        - expiresAt
        - merchant
      properties:
        amount:
          $ref: '#/components/schemas/Amount'
          description: Amount to be paid
        buyer:
          allOf:
            - $ref: '#/components/schemas/BuyerInfo'
          nullable: true
        expiresAt:
          type: integer
          format: int64
          description: Payment expiration timestamp, in seconds since epoch
          minimum: 0
        merchant:
          $ref: '#/components/schemas/MerchantInfo'
          description: Merchant information
        status:
          $ref: '#/components/schemas/PaymentStatus'
          description: Payment status
    PaymentOption:
      type: object
      required:
        - id
        - amount
        - etaS
        - actions
      properties:
        account:
          type: string
          description: CAIP-10 account identifier for this option
        actions:
          type: array
          items:
            $ref: '#/components/schemas/Action'
          description: Actions required to complete the option
        amount:
          $ref: '#/components/schemas/Amount'
          description: The option's token and amount
        etaS:
          type: integer
          format: int64
          description: Estimated time to complete the option, in seconds
          minimum: 0
        collectData:
          allOf:
            - $ref: '#/components/schemas/CollectData'
          nullable: true
          description: >-
            Per-option data collection requirements. When present, the user must
            complete data collection before confirming this option.
        id:
          type: string
          description: >-
            ID of the option to be used to refer to it in other requests. May be
            up to 2^16 characters.
    ErrorCode:
      type: string
      description: Standard error codes for API responses.
      enum:
        - rate_limited
        - invalid_params
        - params_validation
        - payment_not_found
        - internal_error
        - invalid_api_key
        - unauthorized
        - forbidden
        - invalid_state
        - missing_api_key
        - missing_merchant_api_key
        - missing_merchant_id
        - header_not_ascii
        - not_sandbox_api_key
        - merchant_not_found
        - merchant_exists
        - api_key_not_found
    CollectDataField:
      type: object
      required:
        - type
        - id
        - name
        - required
      properties:
        id:
          type: string
          description: ID of the field for submission
        name:
          type: string
          description: Human readable name of the field
        required:
          type: boolean
          description: Requiredness of the field
        type:
          $ref: '#/components/schemas/CollectDataFieldType'
          description: Type of the field
    Amount:
      type: object
      required:
        - unit
        - value
        - display
      properties:
        display:
          $ref: '#/components/schemas/AmountDisplay'
          description: Display information for the amount
        unit:
          type: string
          description: Currency unit, prefixed with either "iso4217/" or "caip19/"
        value:
          type: string
          description: Amount value, in the currency unit's minor units
    BuyerInfo:
      type: object
      required:
        - accountCaip10
        - accountProviderName
      properties:
        accountCaip10:
          type: string
          description: Account CAIP-10
        accountProviderIcon:
          type: string
          nullable: true
          description: Account provider icon URL
        accountProviderName:
          type: string
          description: Account provider name
    MerchantInfo:
      type: object
      required:
        - name
      properties:
        iconUrl:
          type: string
          nullable: true
          description: Merchant icon URL
        name:
          type: string
          description: Merchant name
    PaymentStatus:
      type: string
      description: Payment status representing the lifecycle of a payment.
      enum:
        - requires_action
        - processing
        - succeeded
        - failed
        - expired
    Action:
      oneOf:
        - type: object
          description: An action that requires a wallet RPC call to complete
          required:
            - data
            - type
          properties:
            data:
              $ref: '#/components/schemas/WalletRpcAction'
              description: An action that requires a wallet RPC call to complete
            type:
              type: string
              enum:
                - walletRpc
        - type: object
          description: An action that requires building to complete
          required:
            - data
            - type
          properties:
            data:
              $ref: '#/components/schemas/Build'
              description: An action that requires building to complete
            type:
              type: string
              enum:
                - build
    CollectDataFieldType:
      type: string
      enum:
        - text
        - date
    AmountDisplay:
      type: object
      required:
        - assetSymbol
        - assetName
        - decimals
      properties:
        assetName:
          type: string
          description: Full name of the asset
        assetSymbol:
          type: string
          description: Ticker/symbol of the asset
        decimals:
          type: integer
          format: int32
          description: Number of minor decimals of the asset
          minimum: 0
        iconUrl:
          type: string
          nullable: true
          description: URL of the icon of the asset (if token)
        networkIconUrl:
          type: string
          nullable: true
          description: URL of the icon of the network
        networkName:
          type: string
          nullable: true
          description: Name of the network of the asset (if token)
    WalletRpcAction:
      type: object
      required:
        - chain_id
        - method
        - params
      properties:
        chain_id:
          type: string
        method:
          type: string
        params:
          type: array
          items: {}
    Build:
      type: object
      required:
        - data
      properties:
        data:
          type: string
  securitySchemes:
    API Key:
      type: apiKey
      in: header
      name: Api-Key

````